subroutine dffnor(ndim, baslo, inoff, vnor)
!
    implicit none
!
    real(kind=8) :: baslo(*), vnor(ndim)
    integer :: ndim, inoff
!
! ======================================================================
! COPYRIGHT (C) 1991 - 2012  EDF R&D                  WWW.CODE-ASTER.ORG
! THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
! IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
! THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
! (AT YOUR OPTION) ANY LATER VERSION.
!
! THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
! WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
! MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
! GENERAL PUBLIC LICENSE FOR MORE DETAILS.
!
! YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
! ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
!   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
! ======================================================================
!
! FONCTION REALISEE (OPERATEURS DEFI_FOND_FISS, CALC_G) :
!
!      RETOURNE LE VECTEUR NORMAL AU PLAN DE FISSURE (2EME VECTEUR DE
!      LA BASE LOCALE EN FOND DE FISSURE) EN UN NOEUD
!
! IN
!   NDIM   : DIMENSION DU MAILLAGE
!   BASLO  : VALEURS DE LA BASE LOCALE EN FOND DE FISSURE
!   INOFF  : INCIDE LOCAL DU NOEUD DE LA BASE DEMANDE
!
! OUT
!   VDIR   : VALEURS DU VECTEUR NORMAL AU PLAN DE FISSURE EN CE NOEUD
!
!-----------------------------------------------------------------------
!
    vnor(1) = baslo(2*ndim*(inoff-1)+ndim+1)
    vnor(2) = baslo(2*ndim*(inoff-1)+ndim+2)
    if (ndim .eq. 3) vnor(3) = baslo(2*ndim*(inoff-1)+ndim+3)
!
end subroutine
