subroutine te0084(option, nomte)
! ======================================================================
! COPYRIGHT (C) 1991 - 2013  EDF R&D                  WWW.CODE-ASTER.ORG
! THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
! IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
! THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
! (AT YOUR OPTION) ANY LATER VERSION.
!
! THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
! WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
! MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
! GENERAL PUBLIC LICENSE FOR MORE DETAILS.
!
! YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
! ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
!    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
! ======================================================================
    implicit none
#include "jeveux.h"
!
#include "asterc/r8miem.h"
#include "asterfort/dfdm2d.h"
#include "asterfort/elref4.h"
#include "asterfort/jevech.h"
#include "asterfort/lteatt.h"
#include "asterfort/rccoma.h"
#include "asterfort/rcvalb.h"
#include "asterfort/u2mess.h"
    character(len=16) :: option, nomte
! ......................................................................
!    - FONCTION REALISEE:  CALCUL DES VECTEURS ELEMENTAIRES
!                          OPTION : 'CHAR_MECA_ROTA_R'
!                          2D PLAN ET AXISYMETRIQUE
!    - ARGUMENTS:
!        DONNEES:      OPTION       -->  OPTION DE CALCUL
!                      NOMTE        -->  NOM DU TYPE ELEMENT
! ......................................................................
!
    character(len=16) :: phenom
    integer :: icodre
    real(kind=8) :: dfdx(9), dfdy(9), poids, rx, ry
    integer :: nno, kp, k, npg1, i, ivectu, irota, jgano, ndim, nnos
    integer :: ipoids, ivf, idfde, igeom, imate
!
!
!-----------------------------------------------------------------------
    real(kind=8) :: r8b, rho
!-----------------------------------------------------------------------
    call elref4(' ', 'RIGI', ndim, nno, nnos,&
                npg1, ipoids, ivf, idfde, jgano)
!
    call jevech('PGEOMER', 'L', igeom)
    call jevech('PMATERC', 'L', imate)
    call jevech('PROTATR', 'L', irota)
!
! VERIFICATIONS SUR LE CHARGEMENT ROTATION
!
    if (nomte(3:4) .eq. 'DP' .or. nomte(3:4) .eq. 'CP') then
! AXE=direction Oz
        if (zr(irota+3) .le. r8miem()) then
            call u2mess('F', 'MODELISA9_99')
        endif
        if (zr(irota+1) .gt. r8miem() .or. zr(irota+2) .gt. r8miem()) then
            call u2mess('F', 'MODELISA10_3')
        endif
    else if (nomte(3:4).eq.'AX') then
! AXE=Oy et CENTRE=ORIGINE
        if (zr(irota+1) .gt. r8miem() .or. zr(irota+3) .gt. r8miem()) then
            call u2mess('F', 'MODELISA10_1')
        endif
        if (zr(irota+4) .gt. r8miem() .or. zr(irota+5) .gt. r8miem() .or. zr( irota+6) .gt.&
            r8miem()) then
            call u2mess('F', 'MODELISA10_2')
        endif
    endif
    call jevech('PVECTUR', 'E', ivectu)
!
    call rccoma(zi(imate), 'ELAS', 1, phenom, icodre)
    call rcvalb('FPG1', 1, 1, '+', zi(imate),&
                ' ', phenom, 0, ' ', r8b,&
                1, 'RHO', rho, icodre, 1)
!
    do 101 kp = 1, npg1
        k=(kp-1)*nno
        call dfdm2d(nno, kp, ipoids, idfde, zr(igeom),&
                    dfdx, dfdy, poids)
        poids = poids * rho * zr(irota)**2
        rx= 0.d0
        ry= 0.d0
        do 102 i = 1, nno
            rx= rx+ zr(igeom+2*i-2)*zr(ivf+k+i-1)
            ry= ry+ zr(igeom+2*i-1)*zr(ivf+k+i-1)
102      continue
        if (lteatt(' ','AXIS','OUI')) then
            poids = poids*rx
            do 103 i = 1, nno
                k=(kp-1)*nno
                zr(ivectu+2*i-2) = zr(ivectu+2*i-2) + poids*zr(irota+ 2)**2*rx*zr(ivf+k+i-1)
103          continue
        else
            rx = rx - zr(irota+4)
            ry = ry - zr(irota+5)
            do 104 i = 1, nno
                k=(kp-1)*nno
                zr(ivectu+2*i-2) = zr(ivectu+2*i-2) + poids*zr(irota+ 3)**2*rx*zr(ivf+k+i-1)
                zr(ivectu+2*i-1) = zr(ivectu+2*i-1) + poids*zr(irota+ 3)**2*ry*zr(ivf+k+i-1)
104          continue
        endif
101  end do
end subroutine
